import openmedialib

#
# TODO: Refactor this
#

def change_nothing( input, post ):
	return ""

def turn_thread_on( input, post ):
	if input.get_uri( ) == "threader":
		if post:
			input.properties( ).get_property( "active" ).set( 1 )
		return "[start]"
	return ""

def turn_thread_off( input, post ):
	if input.get_uri( ) == "threader":
		if not post:
			input.properties( ).get_property( "active" ).set( 0 )
		return "[stop]"
	return ""

def dev_stdout( message ):
	print message

def dev_null( message ):
	pass

def walk( input, modifier = change_nothing, logger = dev_stdout, offset = 0 ):
	if input is not None:
		result = modifier( input, False )
		logger( ( " " * offset ) + input.get_uri( ) + result )
		i = 0
		while i < input.slots( ):
			i += walk( input.fetch_slot( i ), modifier, logger, offset + 2 )
		modifier( input, True )
	else:
		logger( ( " " * offset ) + "None" )
	return 1

def activate( input ):
	walk( input, turn_thread_on )

def deactivate( input ):
	walk( input, turn_thread_off, dev_null )
